#! /bin/bash
#
# Run script for Fvdg
# Merry Christmas!
#

# DEFINITIONS
EXECUTABLES=(fvdgfem_LU fvdgfem_LL fvdgfem_BU)
NMESH=(5 10 20 40) 
CFLSCAL=(1.0 0.5)
JITTER=(0.0 0.1 0.2)
TFINAL=10
JITTERMESH=${NMESH[2]}
JITTERCFL=${CFLSCAL[1]}

BASEDIR=.
OUT="out"

# PROGRAM
echo "Main loop"
# loops (general)
for EXEC in ${EXECUTABLES[*]}
do
    DIR=${BASEDIR}/${OUT}_${EXEC##_}
    for MESH in ${NMESH[*]}
    do
	for CFL in ${CFLSCAL[*]}
	do
	  echo "Case: " ${OUT}_${EXEC}_m${MESH}_c${CFL}
	  ${DIR}/${EXEC} -t ${TFINAL} -n ${MESH} -c ${CFL} -f ${DIR}/${OUT}_${EXEC}_m${MESH}_c${CFL}
	done
    done
done

# loops (jitter)
echo "Doing Jitter"
for EXEC in ${EXECUTABLES[*]}
do
    DIR=${BASEDIR}/${OUT}_${EXEC##_}
    MESH=$JITTERMESH
    CFL=$JITTERCFL
    for JITTER in ${JITTER[*]}
    do
	echo "Case: " ${OUT}_${EXEC}_m${MESH}_c${CFL}_j${JITTER}
	${DIR}/${EXEC} -t ${TFINAL} -n ${MESH} -j ${JITTER} -c ${CFL} -f ${DIR}/${OUT}_${EXEC}_m${MESH}_c${CFL}_j${JITTER}
    done
done
