/* plotting graphs from topologies
 */

#include <iostream>
#include <memory>
#include "basics.hh"
#include "geometry.hh"
#include "graphics.hh"
#include "space.hh"
#include "hp2D/element.hh"

#include "square.hh"

using concepts::Real;

int main(int argc, char** argv) {

  using concepts::Real;

  try {
    Square2 msh;
    std::cout << "Mesh: " << msh << std::endl;

    hp2D::Space spc(msh, 0, 2);
    spc.rebuild();
    std::cout << "Space: " << spc << std::endl;
    std::auto_ptr<hp2D::Space::Scan> sc(spc.scan());
//     if (*sc) {
//       hp2D::Element<Real>& element = (*sc)++;
//       concepts::AdaptiveAdjustP<2> a(1, 0);
//       spc.adjust(element, a);
//       spc.rebuild();
//     }
    for (uint i = 0; i < 1; ++i) {
      std::cout << "i = " << i << std::endl;
      sc.reset(spc.scan());
      if (*sc) {
// 	hp2D::Element<Real>& element1 = (*sc)++;
	hp2D::Element<Real>& element = (*sc)++;
	hp2D::Quad* quad = dynamic_cast<hp2D::Quad*>(&element);
	if (quad) {
// 	  if (i%2)
// 	    quad->setStrategy(concepts::Quad2dSubdiv2V::instance());
// 	  else
	    quad->setStrategy(concepts::Quad2dSubdiv2H::instance());
	}
	concepts::AdaptiveAdjustP<2> a(1, 0);
	spc.adjust(element, a);
	spc.rebuild();
      }
    }
    std::cout << "Space: " << spc << std::endl;

    graphics::TopologyDotty<Real> td(spc, "space.dot");
    graphics::drawMeshEPS(msh, "mesh.ps");
    graphics::drawMeshEPS(spc, "space.ps");
  }
  catch(concepts::ExceptionBase& e) {
    std::cout << e << std::endl;
    return 1;
  }

  return 0;
}
