// exception when an iterative method does not converge

#ifndef noConvExc_hh
#define noConvExc_hh

#include "exceptions.hh"

namespace concepts {

  // ********************************************************* NoConvergence **

  /** Exception indicating that the solver did not converge
      up to the desired accuracy in the given number of iterations.

      @author Gregor Schmidlin, 2001.
  */
  class NoConvergence : public MissingFeature {
  public:
    /** Constructor.
	@param errMsg Message which will be printed
    */
    NoConvergence(const std::string& errMsg) throw();
  protected:
    virtual std::ostream& info(std::ostream& os) const throw();
  };

}

#endif // noConvExc_hh
