/* Linear form
 */

#include "basics/typedefs.hh"
#include "linearForm.hh"
#include "geometry/boundaryConditions.hh"

namespace concepts {

  // ************************************************************ LinearForm **

  template<class F>
  std::ostream& LinearForm<F>::info(std::ostream& os) const {
    return os << "LinearForm()";
  }

  template class LinearForm<Real>;

  // *************************************************************** Neumann **

  template<class F>
  Neumann<F>::Neumann(const BoundaryConditions* bc) : bc_(bc) {}

  template<class F>
  Neumann<F>::~Neumann() {}

  template<class F>
  std::ostream& Neumann<F>::info(std::ostream& os) const {
    return os << "Neumann(" << bc_ << ")";
  }

  template class Neumann<Real>;

} // namespace concepts
