/* boundary conditions
 */

#include "toolbox/boundary.hh"
#include "boundaryConditions.hh"
#include "connector.hh"

namespace concepts {

  BoundaryConditions::BoundaryConditions() : boundaries_() {}

  BoundaryConditions::~BoundaryConditions() {}

  void BoundaryConditions::add(const Attribute& attrib, 
			       const Boundary& bcObject) {
    boundaries_.insert(std::pair<uint, Boundary>(attrib.attrib(), bcObject));
  }

  Boundary BoundaryConditions::operator() (Attribute attrib) const {
    return boundaries_[attrib.attrib()];
  }

  std::ostream& BoundaryConditions::info(std::ostream& os) const {

    os << "BoundaryConditions(";
    for (std::map<uint, Boundary>::const_iterator i = boundaries_.begin();
	 i != boundaries_.end(); ++i)
      os << i->first << ": " << i->second << ", ";
    os << "0: " << operator()(0);
    return os << ")";
  }

} // namespace concepts
