// exception throw when illegal subdivision strategy changes occur

#include "strategyChange.hh"
#include "connector.hh"

namespace concepts {

  // ******************************************************** StrategyChange **

  StrategyChange::StrategyChange(const Subdivision& oldStrategy,
				 const Subdivision& newStrategy,
				 const Connector& conn)
    throw() : oldStrategy_(oldStrategy), newStrategy_(newStrategy), conn_(conn)
  {}

  std::ostream& StrategyChange::info(std::ostream& os) const throw() {
    return os << '[' << file_ << ", line " << line_ << "] " << function_ 
	      << " -- illegal change of strategy: old was " << oldStrategy_
	      << ", new should be " << newStrategy_ << " in " << conn_;
  }

} // namespace concepts
