/* test suite for continuity data
 */

#include <iostream>
#include "basics/typedefs.hh"
#include "basics/exceptions.hh"
#include "geometry/topology.hh"
#include "geometry/continuityData.hh"

using namespace concepts;

int main(int, char**) {
  try {
    Vertex v1(1);
    Vertex v2(2);

    Edge e1(v1, v2);
    Edge e2(v2, v1);

    EdgeData ed1(e1);
    EdgeData ed2(e2);
    EdgeData ed10(*e1.child(0));
    EdgeData ed11(*e1.child(1));

    e1.child(0)->child(0)->child(0)->child(0); // create more children

    std::cout << "answer should be 0: " << ed1.related(ed2) << std::endl;
    std::cout << "answer should be 0: " << ed2.related(ed1) << std::endl;
#ifndef __SUNPRO_CC
    std::cout << "answer should be 0: " << ed2.related(ed2) << std::endl;
    std::cout << "answer should be -1: " << ed1.related(ed10) << std::endl;
    std::cout << "answer should be -1: " << ed1.related(ed11) << std::endl;
    std::cout << "answer should be 1: " << ed10.related(ed1) << std::endl;
    std::cout << "answer should be 1: " << ed11.related(ed1) << std::endl;

    Vertex v3;
    Edge e3(v2, v3);
    Edge e4(v3, v1);
    Triangle t1(e1, e3, e4);

    FaceData fd1(t1);
    FaceData fd10(*t1.child(0));
    FaceData fd103(*t1.child(0)->child(3));

    t1.child(0)->child(0)->child(0); // create more children

    std::cout << "answer should be 1: " << fd10.related(fd1) << std::endl;
    std::cout << "answer should be -2: " << fd1.related(fd103) << std::endl;
#endif
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
    return 1;
  }
  return 0;
}
