// additional functionality for quadrilaterals

#include "quadFunctions.hh"
#include "basics/exceptions.hh"
#include "geometry/cell2D.hh"

namespace hp2D {

  // ********************************************************* QuadFunctions **

  void QuadFunctions::edgeOrientation(const uint i, uint& pIndex,
				      uint& qIndex) {
    switch(i) {
    case 0: case 2: pIndex = 0; qIndex = 1; break;
    case 1: case 3: pIndex = 1; qIndex = 0; break;
    default: throw conceptsException(concepts::ExceptionBase());
    }
  }

  void QuadFunctions::vertexIndex(const uint i, uint ll[2]) {
    switch(i) {
    case 0: ll[0] = 0; ll[1] = 0; break;
    case 1: ll[0] = 1; ll[1] = 0; break;
    case 2: ll[0] = 1; ll[1] = 1; break;
    case 3: ll[0] = 0; ll[1] = 1; break;
    default: throw conceptsException(concepts::ExceptionBase());
    }
  }

  void QuadFunctions::edgeIndex(const uint i, const uint qIndex, uint ll[2]) {
    switch (i) {
    case  0: case  3: ll[qIndex] = 0; break;
    case  1: case  2: ll[qIndex] = 1; break;
    default: throw conceptsException(concepts::ExceptionBase());
    }
  }

} // namespace hp2D
