/* testsuite for 2D stiffness matrix for needle elements
 */

#ifndef testMatrices_hh
#define testMatrices_hh

#include "basics/testsuite.hh"
#include "basics/typedefs.hh"

namespace test {

  // ******************************************************** TestMatrices2D **

  /** Mass and stiffness matrices. The matrices are tested
      in a normal (0,1)<sup>2</sup> element and a needle element
      (0,1) x (0, 1/100). The exact values were computed using Mathematica.
      @author Philipp Frauenfelder, 2004
  */
  class TestMatrices2D : public TestCase {
  public:
    virtual ~TestMatrices2D();
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests mass matrix in (0,1)<sup>2</sup>
    void testMassMatrix0101();
    /// Tests mass matrix in (0,1) x (0, 1/100)
    void testMassMatrix010_01();
    /// Tests stiffness matrix in (0,1)<sup>2</sup>
    void testStiffnessMatrix0101();
    /// Tests stiffness matrix in (0,1) x (0, 1/100)
    void testStiffnessMatrix010_01();
    //@}
  };

} // namespace test

#endif // testMatrices_hh
