/** @file hp3D/testsuite/spaceTest.hh Testsuite for 3D hp-FEM space,
    building elements.
    @author Philipp Frauenfelder, 2004
*/

#ifndef spaceTest_hh
#define spaceTest_hh

#include "basics/testcase.hh"

using concepts::Real;

namespace test {

  /** Testing degree of freedom computation.
      @author Philipp Frauenfelder, 2004
   */
  class SpaceTest3D : public TestCase {
  public:
    SpaceTest3D() : elmIdx_(0) {}
    virtual ~SpaceTest3D() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests space (all T matrices of all elements)
    void testSpace();
    //@}
  private:
    void r_(const uint, const uint);
    void c_(const uint, const Real);
    std::list<std::pair<uint, uint> > rowIdx_[16];
    std::list<std::pair<uint, Real> > colAndEntry_[16];
    uint elmIdx_;
  };

} // namespace test

#endif // spaceTest_hh
