// graphics for DGTriangles

#ifndef dgTriangleGraphics_hh
#define dgTriangleGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace linDG2D {

  using concepts::Real;

  // ****************************************************** TriangleGraphics **

  /** Handles graphics for triangular DGFEM elements in 2D.
      @author Christoph Winkelmann, 2003
  */
  class TriangleGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
                            enum graphicsType type,
                            concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace linDG2D

#endif // dgTriangleGraphics_hh
