// graphics for lines

#ifndef linLineGraphics_hh
#define linLineGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace linearFEM {

  using concepts::Real;

  // ********************************************************** LineGraphics **

  /** Handles graphics for linear finite elements in 1D.
      @author Philipp Frauenfelder, 2002
  */
  class LineGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace linearFEM

#endif // linLineGraphics_hh
