// graphics for triangles

#ifndef linTriangleGraphics_hh
#define linTriangleGraphics_hh

#include "basics/typedefs.hh"
#include "toolbox/elementGraphics.hh"

namespace linearFEM {

  using concepts::Real;

  // ****************************************************** TriangleGraphics **

  /** Handles graphics for linear triangles FEM elements in 2D.
      @author Philipp Frauenfelder, 2002
  */
  class TriangleGraphics : public concepts::ElementGraphics<Real> {
  public:
    virtual void operator()(const concepts::Element<Real>& elm,
			    enum graphicsType type,
			    concepts::CellPostprocess<Real>& post) const;
  protected:
    virtual std::ostream& info(std::ostream& os) const;
  };

} // namespace linearFEM

#endif // linTriangleGraphics_hh
