// fabric class for SuperLU

#ifndef superLUfabric_hh
#define superLUfabric_hh

#include "superLU.hh"
#include "solverFabric.hh"
#include "sparseMatrix.hh"

namespace concepts {

  // ********************************************************* SuperLUFabric **

  /** Fabric class for \c SuperLU.
      @author Philipp Frauenfelder, 2002
  */
  class SuperLUFabric : public SolverFabric<Real> {
  public:
    virtual Operator<Real>* operator()(Operator<Real>& matrix) {
      if (dynamic_cast<concepts::SparseMatrix<Real>*>(&matrix))
	return new SuperLU(matrix);
      else {
	concepts::SparseMatrix<Real> tmpMatrix(matrix);
	return new SuperLU(tmpMatrix);
      }
    }
  protected:
    virtual std::ostream& info(std::ostream& os) const {
      return os << "SuperLUFabric()";
    }
  };

} // concepts

#endif // superLUfabric_hh
