/** @file sparseMatrix.hh
    Testsuite for SparseMatrix
    @author Philipp Frauenfelder, 2004
*/

#ifndef sparseMatrixTest_hh
#define sparseMatrixTest_hh

#include "basics/testcase.hh"
#include "space/space.hh"

using concepts::Real;

namespace test {

  /** Test sparse matrix class SparseMatrix.
      @author Philipp Frauenfelder, 2004
      @see concepts::SparseMatrix
  */
  class SparseMatrixTest : public TestCase {
  public:
    SparseMatrixTest() : spc3(3), spc4(4) {}
    virtual ~SparseMatrixTest() {}
    virtual void run();

    /// @name Test routines
    //@{
    /// Tests the constructors
    void testConstr();
    /// Tests the application operator
    void testAppl();
    /// Tests the transposed multiplication operator
    void testTranspMult();
    /// Tests the addition of two matrices
    void testAddInto();
    /// Tests multiplication of two matrices
    void testMult();
    /// Tests symmetrization of a matric
    void testSymmetrize();
    /// Tests compressing a matrix
    void testCompress();
    //@}
  private:
    concepts::DummySpace<concepts::Real> spc3, spc4;
  };

} // namespace test

#endif // sparseMatrixTest_hh
