#include "transpose.hh"
#include "basics/typedefs.hh"

namespace concepts {

  template<class F>
  void Transpose<F>::operator()(const Function<F>& fncY, Function<F>& fncX) {
    const Vector<F>* fncYA;
    if ((fncYA = dynamic_cast<const Vector<F>*>(&fncY))) {
      Vector<F>* fncXA;
      if ((fncXA = dynamic_cast<Vector<F>*>(&fncX))) {
        (*this)(*fncYA, *fncXA); return;
      }
    }
    throw conceptsException(MissingFeature("function not supported"));
  }

  template<class F>
  std::ostream& Transpose<F>::info(std::ostream& os) const {
    return os << "Transpose(" << a_ << ")";
  }

  template class Transpose<Real>;
  template class Transpose<Cmplx>;

} // namespace concepts
