// fabric class for Umfpack

#ifndef umfpackFabric_hh
#define umfpackFabric_hh

#include "umfpack.hh"
#include "solverFabric.hh"

namespace concepts {

  // ********************************************************* UmfpackFabric **

  /** Fabric class for \c Umfpack.
      @author Philipp Frauenfelder, 2002
  */
  class UmfpackFabric : public SolverFabric<Real> {
  public:
    UmfpackFabric(bool symmetric = false) : symmetric_(symmetric) {}
    virtual Operator<Real>* operator()(Operator<Real>& matrix) {
      return new Umfpack(matrix, symmetric_);
    }
    virtual Operator<Real>* operator()(SparseMatrix<Real>& matrix) {
      return new Umfpack(matrix, symmetric_);
    }
  protected:
    virtual std::ostream& info(std::ostream& os) const {
      return os << "UmfpackFabric()";
    }
  private:
    bool symmetric_;
  };

} // concepts

#endif // umfpackFabric_hh
