// include files for the space subdirectory

#ifndef space_hh
#define space_hh

#include "space/element.hh"
#include "space/elementPairs.hh"
#include "space/tmatrix.hh"
#include "space/smatrix.hh"
#include "space/space.hh"
#include "space/postProcess.hh"
#include "space/function.hh"

#endif // space_hh

/** @defgroup space Elements and Space
    Description of elements and spaces.
    <h2>Elements</h2>

    A space in Concepts consists of elements. Usually, these are built
    on the cells of a mesh. All elements contain the information on
    the assembling of their local element matrices and vectors in the
    T matrices (see concepts::TMatrixBase).

    The base class for the elements is concepts::Element.
    <h2>Space</h2>

    A space is a collection of elements with a scanner which makes it
    possible to loop over the elements. When constructing the space,
    it creates the elements (including the computation of the T
    matrices).

    All spaces are derived from concepts::Space.

    @author Philipp Frauenfelder, 2004
*/
