/* testsuite for adaptive space
 */

#include <iostream>
#include "space.hh"

using namespace concepts;

int main(int argc, char** argv) {

  concepts::AdaptiveControl ctrl;
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.deactivate();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.activate();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_ = 255;
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.activate();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.deactivate();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;

  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isMember() ? "" : "not ") << "member" << std::endl;
  ctrl.tag_.takeOut();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isMember() ? "" : "not ") << "member" << std::endl;
  ctrl.tag_.takeIn();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isMember() ? "" : "not ") << "member" << std::endl;

  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.idxValid() ? "valid" : "invalid")
	    << " idx" << std::endl;
  ctrl.tag_.invalidateIdx();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.idxValid() ? "valid" : "invalid")
	    << " idx" << std::endl;
  ctrl.tag_.validateIdx();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.idxValid() ? "valid" : "invalid")
	    << " idx" << std::endl;

  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.pValid() ? "valid" : "invalid") << " p" << std::endl;
  ctrl.tag_.invalidateP();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.pValid() ? "valid" : "invalid") << " p" << std::endl;
  ctrl.tag_.validateP();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.pValid() ? "valid" : "invalid") << " p" << std::endl;

  ctrl.tag_ = 0;
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.deactivate();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isActive() ? "active" : "passive") << std::endl;
  ctrl.tag_.takeIn();
  std::cout << "ctrl = " << ctrl << " is "
	    << (ctrl.tag_.isMember() ? "" : "not ") << "member" << std::endl;
  ctrl.tag_.validateIdx();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.idxValid() ? "valid" : "invalid")
	    << " idx" << std::endl;
  ctrl.tag_.validateP();
  std::cout << "ctrl = " << ctrl << " has "
	    << (ctrl.tag_.pValid() ? "valid" : "invalid") << " p" << std::endl;

  return 0;
}
