/* testing formula
 */

#include "basics/exceptions.hh"
#include "basics/vectorsMatrices.hh"
#include "toolbox/formula.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    ParsedFormula a("(x+y+z)");
    std::cout << a << std::endl;
    std::cout << a(Real3d(1, 2, 3)) << std::endl;

    ZylindricalFormula b("(x+y+z)");
    std::cout << b << std::endl;
    std::cout << b(Real3d(1, 2, 3)) << std::endl;
    std::cout << b(Real3d((Real)0, (Real)0, (Real)0)) << std::endl;

    SphericalFormula c("(x+y+z)");
    std::cout << c << std::endl;
    std::cout << c(Real3d(1, 2, 3)) << std::endl;
    std::cout << c(Real3d((Real)0, (Real)0, (Real)0)) << std::endl;
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl;
    return 1;
  }

  return 0;
}
