/* testing parameter handling
 */

#include "basics/exceptions.hh"
#include "basics/typedefs.hh"
#include "toolbox/resultsTable.hh"

int main(int, char**) {

  using namespace concepts;

  try {
    InOutParameters output;

    output.addArrayDouble("energieFehler");
    output.addArrayDouble("feenergy");
    output.addArrayInt("dof");
    output.addArrayInt("iterations");

    for (uint i = 0; i < 10; ++i) {
      output.addArrayDouble("energieFehler", i, 1.0/(double)i);
      output.addArrayDouble("feenergy", i, 1.1);
      output.addArrayInt("dof", i, 2*i);
      output.addArrayInt("iterations", i, 3*i);
    }

    ResultsTable table;
    table.addMap(concepts::ResultsTable::DOUBLE, "energieFehler", output);
    table.addMap(concepts::ResultsTable::DOUBLE, "feenergy", output);
    table.addMap(concepts::ResultsTable::INT, "dof", output);
    table.addMap(concepts::ResultsTable::INT, "iterations", output);
    std::cout << table << std::endl;

//     std::cout << "for gnuplot:" << std::endl
// 	      << table.print<ResultsTable::GNUPLOT>(std::cout);
  }
  catch (ExceptionBase& e) {
    std::cout << e << std::endl; 
    return 1;
  }

  return 0;
}
